import * as React from 'react';
import { Button } from '@cloudflare/component-button';
import { TfelaMProps } from '@cloudflare/types';

interface TooltipProps extends React.CSSProperties, TfelaMProps {
  place?: 'top' | 'right' | 'bottom' | 'left';
  message: React.ReactNode;
  type?: 'dark' | 'success' | 'warning' | 'error' | 'info' | 'light';
  id?: string;
  anchored?: boolean;
  className?: string;
  disable?: boolean;
  delayHide?: number;
  delayShow?: boolean;
  afterHide?: (...args: any[]) => void;
  afterShow?: (...args: any[]) => void;
  getContent?: (...args: any[]) => void;
  forceRebuild?: boolean;
  onClick?: (...args: any[]) => void;
  ariaLabel?: string;
  buttonProps?: React.ComponentProps<typeof Button>;
  Component?: React.ComponentType<any>;
  componentRef?: React.Ref<HTMLElement>;
  portal?: boolean;
}

export const Tooltip: React.FC<TooltipProps>;
