"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tooltipStyles = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDom = require("react-dom");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _elements = require("@cloudflare/elements");

var _styleContainer = require("@cloudflare/style-container");

var _reactTooltip = _interopRequireDefault(require("react-tooltip"));

var _lodash = _interopRequireDefault(require("lodash.uniqueid"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var DELAY_SHOW_MILLIS = 400;

var getBackgroundColor = function getBackgroundColor(theme, type) {
  if (type === 'dark') {
    return "".concat(theme.colors.gray[2], " !important");
  }

  if (type === 'success') {
    return "".concat(theme.colors.green[6], " !important");
  }

  return 'inherit';
};

var tooltipStyles = function tooltipStyles(_ref) {
  var theme = _ref.theme,
      type = _ref.type,
      place = _ref.place;
  return {
    '&:after': {
      borderTopColor: place === 'top' ? getBackgroundColor(theme, type) : 'inherit',
      borderRightColor: place === 'right' ? getBackgroundColor(theme, type) : 'inherit',
      borderLeftColor: place === 'left' ? getBackgroundColor(theme, type) : 'inherit',
      borderBottomColor: place === 'bottom' ? getBackgroundColor(theme, type) : 'inherit'
    },
    color: "".concat(theme.colors.white, " !important"),
    backgroundColor: getBackgroundColor(theme, type),
    opacity: '1 !important',
    fontSize: "".concat(theme.fontSizes[1], "px !important"),
    borderRadius: '2px !important',
    maxWidth: '21rem !important',
    paddingLeft: "".concat(theme.space[3], "px !important"),
    paddingRight: "".concat(theme.space[3], "px !important"),
    paddingTop: "".concat(theme.space[2], "px !important"),
    paddingBottom: "".concat(theme.space[2], "px !important"),
    fontWeight: 'normal !important',
    lineHeight: '1.5 !important',
    pointerEvents: 'auto !important',
    verticalAlign: 'baseline !important',
    whiteSpace: 'normal',
    zIndex: '1300 !important',
    '&:hover': {
      visibility: 'visible !important',
      opacity: '1 !important'
    },
    '& a': {
      color: theme.colors.white,
      textDecoration: 'underline',
      ':hover': {
        textDecoration: 'none'
      }
    }
  };
};

exports.tooltipStyles = tooltipStyles;

var Tooltip = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(Tooltip, _React$PureComponent);

  var _super = _createSuper(Tooltip);

  function Tooltip(props) {
    var _this;

    _classCallCheck(this, Tooltip);

    _this = _super.call(this, props);
    _this.id = (0, _lodash.default)('cf_component_tooltip_');
    _this.escFunction = _this.escFunction.bind(_assertThisInitialized(_this));
    _this.delayTimer = null;
    return _this;
  }

  _createClass(Tooltip, [{
    key: "escFunction",
    value: function escFunction(event) {
      if (event.key === 'Escape') {
        _reactTooltip.default.hide(this.tooltipElement);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var _this2 = this;

      // full rebuild is required when tooltip is already displayed
      // but we changed type of position of the tooltip
      if (this.props.forceRebuild) {
        _reactTooltip.default.hide(this.tooltipElement);

        setTimeout(function () {
          return _reactTooltip.default.show(_this2.tooltipElement);
        }, 0);
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      document.addEventListener('keydown', this.escFunction, {
        capture: true
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      document.removeEventListener('keydown', this.escFunction, {
        capture: true
      });
      clearTimeout(this.delayTimer);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props = this.props,
          disable = _this$props.disable,
          place = _this$props.place,
          message = _this$props.message,
          children = _this$props.children,
          className = _this$props.className,
          delayHide = _this$props.delayHide,
          delayShow = _this$props.delayShow,
          afterHide = _this$props.afterHide,
          afterShow = _this$props.afterShow,
          getContent = _this$props.getContent,
          type = _this$props.type,
          anchored = _this$props.anchored,
          buttonProps = _this$props.buttonProps,
          isCapture = _this$props.isCapture,
          display = _this$props.display,
          ariaLabel = _this$props.ariaLabel,
          _this$props$Component = _this$props.Component,
          Component = _this$props$Component === void 0 ? _elements.Button : _this$props$Component,
          componentRef = _this$props.componentRef,
          _this$props$portal = _this$props.portal,
          portal = _this$props$portal === void 0 ? false : _this$props$portal;
      var id = this.props.id ? this.props.id : this.id;
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, portal ? /*#__PURE__*/(0, _reactDom.createPortal)( /*#__PURE__*/_react.default.createElement(_reactTooltip.default, {
        id: id,
        disable: disable,
        place: place,
        type: type,
        effect: anchored ? 'solid' : 'float',
        className: className,
        isCapture: isCapture,
        delayHide: delayHide ? delayHide : null,
        afterShow: afterShow,
        afterHide: afterHide,
        getContent: [function () {
          return message || getContent();
        }],
        onClick: this.props.onClick,
        event: "click",
        role: "status"
      }), document.body) : /*#__PURE__*/_react.default.createElement(_reactTooltip.default, {
        id: id,
        disable: disable,
        place: place,
        type: type,
        effect: anchored ? 'solid' : 'float',
        className: className,
        isCapture: isCapture,
        delayHide: delayHide ? delayHide : null,
        afterShow: afterShow,
        afterHide: afterHide,
        getContent: [function () {
          return message || getContent();
        }],
        onClick: this.props.onClick,
        event: "click",
        role: "status"
      }), /*#__PURE__*/_react.default.createElement(Component, _extends({
        innerRef: function innerRef(ref) {
          _this3.tooltipElement = ref;

          if (componentRef !== null && componentRef !== void 0 && componentRef.hasOwnProperty('current')) {
            componentRef.current = ref;
          } else if (typeof componentRef === 'function') {
            componentRef(ref);
          }
        },
        display: display ? display : 'flex',
        pointerEvents: "bounding-box",
        padding: 0,
        backgroundColor: "transparent",
        cursor: "pointer",
        borderWidth: 0,
        "data-tip": true,
        "data-for": id,
        type: "button",
        onFocus: function onFocus() {
          return _reactTooltip.default.show(_this3.tooltipElement);
        },
        onBlur: function onBlur() {
          return _reactTooltip.default.hide(_this3.tooltipElement);
        },
        color: "gray.1",
        onClick: function onClick(e) {
          e.stopPropagation();
        },
        onMouseOver: function onMouseOver() {
          if (delayShow) {
            _this3.delayTimer = setTimeout(function () {
              _reactTooltip.default.show(_this3.tooltipElement);
            }, DELAY_SHOW_MILLIS);
          } else {
            _reactTooltip.default.show(_this3.tooltipElement);
          }
        },
        onMouseOut: function onMouseOut() {
          clearTimeout(_this3.delayTimer);

          _reactTooltip.default.hide(_this3.tooltipElement);
        },
        "aria-controls": id,
        "aria-label": ariaLabel,
        "aria-describedby": id
      }, buttonProps), children));
    }
  }]);

  return Tooltip;
}(_react.default.PureComponent);

Tooltip.propTypes = {
  id: _propTypes.default.string,
  message: _propTypes.default.node.isRequired,
  place: _propTypes.default.oneOf(['top', 'right', 'bottom', 'left']),
  type: _propTypes.default.oneOf(['dark', 'success', 'warning', 'error', 'info', 'light']),
  anchored: _propTypes.default.bool,
  className: _propTypes.default.string,
  isCapture: _propTypes.default.bool,
  children: _propTypes.default.node,
  disable: _propTypes.default.bool,
  delayHide: _propTypes.default.number,
  delayShow: _propTypes.default.bool,
  afterHide: _propTypes.default.func,
  afterShow: _propTypes.default.func,
  buttonProps: _propTypes.default.object,
  getContent: _propTypes.default.func,
  forceRebuild: _propTypes.default.bool,
  onClick: _propTypes.default.func,
  display: _propTypes.default.string,
  ariaLabel: _propTypes.default.string,
  Component: _propTypes.default.func,
  // Allow the Component element to be referenced from a parent. innerRef
  // is swallowed by createComponent.
  componentRef: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.object]),
  portal: _propTypes.default.bool
};
Tooltip.defaultProps = {
  disable: false,
  place: 'top',
  type: 'dark',
  anchored: true,
  isCapture: true,
  forceRebuild: false,
  delayShow: true,
  portal: false
};
Tooltip.displayName = 'Tooltip';

var _default = (0, _styleContainer.createComponent)(tooltipStyles, Tooltip);

exports.default = _default;